﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="EndPoint.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2010, 2011
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Collision.
//
//   starLiGHT.Collision is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Collision is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Collision. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 3062                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-01-06 10:38:34 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Collision.BroadPhase
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Text;
    #endregion

    public struct EndPoint : IComparable<EndPoint>
    {
        public uint OwnerHash { get; set; }

        public float Value { get; set; }
        
        public bool IsMin { get; set; }

        public int CompareTo(EndPoint other)
        {
            if (this.Value < other.Value)
            {
                return -1;
            }
            else if (this.Value > other.Value)
            {
                return 1;
            }
            else if (this.Value == other.Value && this.IsMin == other.IsMin)
            {
                return 0;
            }
            else if (this.Value == other.Value && this.IsMin)
            {
                return -1;
            }
            else if (this.Value == other.Value && !this.IsMin)
            {
                return 1;
            }

            throw new NotImplementedException("unknown sorting case");
        }
    }
}
