﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="CollisionEventArgs.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Collision.
//
//   starLiGHT.Collision is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Collision is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Collision. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 3062                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-01-06 10:38:34 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Collision
{
    #region Using Statements
    using System;
    #endregion

    public class CollisionEventArgs : EventArgs
    {
        private UserPair<ICollidable> pair;
        private CollisionManifold<ICollidable> manifold;

        public CollisionEventArgs(UserPair<ICollidable> pair, CollisionManifold<ICollidable> manifold)
        {
            this.pair = pair;
            this.manifold = manifold;
        }

        public UserPair<ICollidable> Pair
        {
            get { return this.pair; }
            set { this.pair = value; }
        }

        public CollisionManifold<ICollidable> Manifold
        {
            get { return this.manifold; }
            set { this.manifold = value; }
        }
    }
}
