﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="WeightValuePair.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2010 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Core.
//
//   starLiGHT.Core is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Core is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Core. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Core are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 620                   $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2010-12-07 15:23:58 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Collections
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Text;

    #endregion

    /// <summary>
    /// A generic, weighted value to be used by the WeightedList
    /// </summary>
    /// <typeparam name="T">
    /// Type of the value 
    /// </typeparam>
    public class WeightValuePair<T>
    {
        private float key;
        private T value;

        public WeightValuePair(float key, T value)
        {
            this.key = key;
            this.value = value;
        }

        public float Weight
        {
            get { return this.key; }
        }

        public T Value
        {
            get { return this.value; }
        }

        public override string ToString()
        {
            StringBuilder builder = new StringBuilder();
            builder.Append('[');
            builder.Append(this.key.ToString());
            builder.Append(", ");
            if (this.Value != null)
            {
                builder.Append(this.value.ToString());
            }

            builder.Append(']');

            return builder.ToString();
        }
    }
}
