﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="InputExtensions.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2007, 2008, 2009, 2010 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Core.
//
//   starLiGHT.Core is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Core is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Core. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Core are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 620                   $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2010-12-07 15:23:58 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT
{
    #region Using Statements
    using System;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Input;

    #endregion

    /// <summary>
    /// Extension methods for Input Handling
    /// </summary>
    public static class InputExtensions
    {
        /// <summary>
        /// Returns the mouse position as Vector2
        /// </summary>
        /// <param name="mouse">
        /// The underlying MouseState
        /// </param>
        /// <returns>
        /// Returns the actual MousePosition as Vector2.
        /// </returns>
        public static Vector2 GetPosition(this MouseState mouse)
        {
#if XBOX || ZUNE || WINDOWS_PHONE
            Vector2 ret = Vector2.Zero;
#else
            Vector2 ret; 
#endif
            ret.X = mouse.X; 
            ret.Y = mouse.Y;
            
            return ret;
        }
    }
}
