﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="DefaultSkin.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 10017                 $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-05-15 23:28:27 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
#region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Text;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Graphics;
#endregion

    public enum TilePosition : int
    {
        TopLeft      = 0,
        Top          = 1,
        TopRight     = 2,
        CenterLeft   = 3,
        Center       = 4,
        CenterRight  = 5,
        BottomLeft   = 6,
        BottomCenter = 7,
        BottomRight  = 8,
    }

    public static class DefaultSkin
    {
        private static Vector2 uv = new Vector2(1f / 512f, 1f / 512f);

        public static string SkinAssetName
        {
            get
            {
                return @"Textures/DarkSkin";
            }
        }
        
        public static Color Widget
        {
            get
            {
                return Color.Black;
            }
        }

        public static Color WidgetText
        {
            get
            {
                return Color.White;
            }
        }

        public static Color TitleBarColor
        {
            get
            {
                return Color.LightGray;
            }
        }
    }
}
