﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="IGuiRenderer.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 9623                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-05-02 22:25:06 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Graphics;
    using starLiGHT.GUI.Widgets;
    #endregion

    public interface IGuiRenderer
    {
        GuiManager GuiManager { get; }

        void Draw(GameTime gameTime);

        void DrawLayer(Widget w, Layer l);

        void DrawSprite(Texture2D texture, float depth, float x, float y, float width, float height, float texX, float texY, float texWidth, float texHeight, Color tint);

        void DrawString(SpriteFont font, string text, Vector2 topLeft, Color color);

        void DrawFilledRectangle(RectangleF rect, Color color);

        void ScissorPush(RectangleF scissor);

        void ScissorPop();
    }
}
