﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="ScissorStatus.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 9623                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-05-02 22:25:06 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
    #endregion

    public class ScissorStatus
    {
#if !XNA4
        public ScissorStatus(bool scissorEnabled, Rectangle scissorRectangle)
        {
            this.ScissorEnabled = scissorEnabled;
            this.ScissorRectangle = scissorRectangle;
        }

        public bool ScissorEnabled
        {
            get;
            set;
        }
#else
        public ScissorStatus(RasterizerState rasterizerState, Rectangle scissorRectangle)
        {
            this.RasterizerState = rasterizerState;
            this.ScissorRectangle = scissorRectangle;
        }

        public RasterizerState RasterizerState
        {
            get;
            set;
        }
#endif

        public Rectangle ScissorRectangle
        {
            get;
            set;
        }
    }
}
