﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="Image.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 10298                 $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-06-06 23:49:52 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
#endregion

    public class Image : SkinElement
    {
        #region Private Members
        private Imageset imageSet;
        private RectangleF rect;
        private Texture2D texture;
        #endregion

        public Image(Imageset imageset, string name)
            : base(name)
        {
            this.imageSet = imageset;
        }

        public RectangleF Rectangle
        {
            get
            {
                return this.rect;
            }

            set
            {
                this.rect = value;
            }
        }

        public Imageset Imageset
        {
            get
            {
                return this.imageSet;
            }
        }

        public Texture2D Texture
        {
            get
            {
                if (Imageset == null && this.texture == null)
                {
                    this.texture = Imageset.Skin.GuiManager.LoadContent<Texture2D>(Imageset.Name);
                }

                if (Imageset == null)
                {
                    return this.texture;
                }
                else
                {
                    return Imageset.Texture;
                }
            }
        }
    }
}
