﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="Imageset.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 10298                 $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-06-06 23:49:52 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
#endregion

    public class Imageset : SkinElement
    {
        #region Private Memebers
        private Skin skin;
        private List<Image> images = new List<Image>();
        private Texture2D texture;
        #endregion

        public Imageset(Skin skin, string name)
            : base(name)
        {
            this.skin = skin;
        }

        public IEnumerable<Image> Images
        {
            get
            {
                foreach (Image image in this.images)
                {
                    yield return image;
                }
            }
        }

        public Skin Skin
        {
            get
            {
                return this.skin;
            }
        }

        public Texture2D Texture
        {
            get
            {
                if (this.texture == null)
                {
                    this.texture = Skin.GuiManager.LoadContent<Texture2D>(Name);
                }

                return this.texture;
            }
        }

        public void AddImage(Image image)
        {
            if (image == null)
            {
                throw new ArgumentNullException("image");
            }

            this.images.Add(image);
        }
    }
}
