﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="Property.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011 
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.GUI.
//
//   It is released under the Microsoft Public License (Ms-PL).
//
//   You should have received a copy of the Microsoft Public License
//   along with starLiGHT.GUI. If not, see http://sle.codeplex.com/license.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.GUI are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev::                       $:  Revision of last commit *
// * $Author::                    $:  Author of last commit   *
// * $Date::                      $:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.GUI
{
#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
#endregion

    public class Property : SkinElement
    {
        #region Member Variables
        private Layout layout;
        private string stringValue;
        private string valueType;
        private float floatValue;
        private int intValue;
        #endregion

        public Property(Layout layout, string name)
            : base(name)
        {
            this.layout = layout;
        }

        public string StringValue
        {
            get
            {
                return this.stringValue;
            }

            set
            {
                this.stringValue = value;
            }
        }

        public float FloatValue
        {
            get
            {
                return this.floatValue;
            }

            set
            {
                this.floatValue = value;
            }
        }

        public int IntegerValue
        {
            get
            {
                return this.intValue;
            }

            set
            {
                this.intValue = value;
            }
        }

        public string ValueType
        {
            get
            {
                return this.valueType;
            }

            set
            {
                this.valueType = value;
            }
        }

        public Layout Layout
        {
            get
            {
                return this.layout;
            }
        }
    }
}
