﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2007, 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Input.

    starLiGHT.Input is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Input is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Input.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Input are available on request.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 5197                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-02-15 07:08:45 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Input
{
    public enum PositionalDirection
    {
        LEFT,
        RIGHT,
        UP,
        DOWN,
    }

    public class PositionalToDigitalAdapter : IDigitalControl
    {
        IPositionalControl control;
        float threshold;
        PositionalDirection direction;

        public PositionalToDigitalAdapter(IPositionalControl control, PositionalDirection direction)
        {
            this.control = control;
            this.direction = direction;
            this.threshold = 0.25f;
        }

        public PositionalToDigitalAdapter(IPositionalControl control, PositionalDirection direction, float threshold)
        {
            this.control = control;
            this.direction = direction;
            this.threshold = threshold;
        }

        public float Value
        {
            get
            {
                switch (direction)
                {
                    case PositionalDirection.LEFT:
                        return Math.Abs(Math.Min(control.Position.X, 0f));
                    case PositionalDirection.RIGHT:
                        return Math.Max(control.Position.X, 0f);
                    case PositionalDirection.UP:
                        return Math.Max(control.Position.Y, 0f);
                    case PositionalDirection.DOWN:
                        return Math.Abs(Math.Min(control.Position.Y, 0f));
                }

                return 0f;
            }
        }

        public bool Pressed
        {
            get { return (Value >= threshold); }
        }

        public bool Released
        {
            get { return (Value < threshold); }
        }
    }
}
