﻿#region Using Statements
using System;
using Microsoft.Xna.Framework;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2007, 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Input.

    starLiGHT.Input is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Input is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Input.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Input are available on request.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1496                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-10-11 09:38:05 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Input
{
    public class DigitalInvertableDirectionControl : IDigitalDirectionControl
    {
        IDigitalDirectionControl dirControl;

        bool invertX;
        bool invertY;

        public DigitalInvertableDirectionControl(IDigitalDirectionControl directionalControl)
            : this(directionalControl, false, false)
        {
        }

        public DigitalInvertableDirectionControl(IDigitalDirectionControl directionalControl, bool InvertXAxis)
            : this(directionalControl, InvertXAxis, false)
        {
        }

        public DigitalInvertableDirectionControl(IDigitalDirectionControl directionalControl, bool InvertXAxis, bool InvertYAxis)
        {
            this.dirControl = directionalControl;
            this.invertX = InvertXAxis;
            this.invertY = InvertYAxis;
        }

        public DigitalInvertableDirectionControl(IDigitalControl up, IDigitalControl down, IDigitalControl left, IDigitalControl right)
            : this(new DigitalDirectionControl(up, down, left, right), false, false)
        {
        }

        public bool Up
        {
            get { return invertY ? dirControl.Down : dirControl.Up; }
        }

        public bool Down
        {
            get { return invertY ? dirControl.Up : dirControl.Down; }
        }

        public bool Left
        {
            get { return invertX ? dirControl.Right : dirControl.Left; }
        }

        public bool Right
        {
            get { return invertX ? dirControl.Left : dirControl.Right; }
        }
    }
}
