﻿#region Using Statements
using System;
using Microsoft.Xna.Framework;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2007, 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Input.

    starLiGHT.Input is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Input is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Input.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Input are available on request.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1632                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-11-10 19:19:59 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Input
{
    public class ScreenPositionControl : IPositionalControl
    {
        Vector2 lastPosition = Vector2.Zero;
        Vector2 actPosition = Vector2.Zero;

        public ScreenPositionControl()
        {
        }

        internal ScreenPositionControl(Vector2 pos)
        {
            lastPosition = actPosition = pos;
        }

        internal void Update(Vector2 pos)
        {
            lastPosition = actPosition;
            actPosition = pos;
        }

        internal void Update(int x, int y)
        {
            lastPosition = actPosition;
            actPosition.X = x;
            actPosition.Y = y;
        }

        public Vector2 Position
        {
            get { return actPosition; }
        }

        public Vector2 Delta
        {
            get { return lastPosition - actPosition; }
        }


        public bool IsValid
        {
            get { return true; }
        }
    }
}
