﻿#region Using Statements
using System;
using Microsoft.Xna.Framework;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2007, 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Input.

    starLiGHT.Input is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Input is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Input.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Input are available on request.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1496                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-10-11 09:38:05 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Input
{
    public class ThreeAxisControl : IPositional3DControl
    {
        Vector3 lastPosition = Vector3.Zero;
        Vector3 actPosition = Vector3.Zero;

        internal ThreeAxisControl(Vector3 initialValue)
        {
            lastPosition = actPosition = initialValue;
        }

        internal void Update(Vector3 position)
        {
            lastPosition = actPosition;
            actPosition = position;
        }

        internal void Update(float x, float y, float z)
        {
            lastPosition = actPosition;
            actPosition.X = x;
            actPosition.Y = y;
            actPosition.Z = z;
        }

        internal void Update(double x, double y, double z)
        {
            lastPosition = actPosition;
            actPosition.X = (float)x;
            actPosition.Y = (float)y;
            actPosition.Z = (float)z;
        }

        internal void Update(int x, int y, int z)
        {
            lastPosition = actPosition;
            actPosition.X = x;
            actPosition.Y = y;
            actPosition.Z = z;
        }

        public Vector3 Position
        {
            get { return actPosition; }
        }

        public Vector3 Delta
        {
            get { return lastPosition - actPosition; }
        }
    }
}
