#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="Emitter2DReader.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2008, 2009, 2010, 2011
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Particles.
//
//   starLiGHT.Particles is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Particles is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Particles. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Particles are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 5425                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-02-18 06:38:38 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.ContentPipeline
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Content;
    using Microsoft.Xna.Framework.Graphics;
    using starLiGHT.ContentPipeline.ParticleSystem;
    using starLiGHT.ParticleSystem;
    using starLiGHT.ParticleSystem.Initializer;
    using starLiGHT.ParticleSystem.Initializer.TwoD;
    using TRead = starLiGHT.ParticleSystem.twoD.Emitter2D;
    #endregion

    public class Emitter2DReader : ContentTypeReader<TRead>
    {
        protected override TRead Read(ContentReader input, TRead existingInstance)
        {
            TRead emitter = new starLiGHT.ParticleSystem.twoD.Emitter2D();

            emitter.Name = input.ReadString();

            // read pulse generators
            emitter.PulseGenerator = ContentReaderHelper.ContentReadPulseGenerator(input);

            // read initializers
            int initializerCount = input.ReadInt32();

            for (int i = 0; i < initializerCount; i++)
            {
                emitter.Initializers.Add(ContentReaderHelper.ContentReadInitializer(input));
            }

            // read modifiers
            int modifierCount = input.ReadInt32();

            for (int i = 0; i < modifierCount; i++)
            {
                emitter.Modifiers.Add(ContentReaderHelper.ContentReadModifier(input));
            }

            return emitter;
        }
    }
}
