﻿using System;
using System.Collections.Generic;
using System.Text;

#region COPYRIGHT

/*
    Copyright (c) 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Collision.

    starLiGHT.Collision is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Collision is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Collision.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

namespace starLiGHT.Physic.TwoD
{
    public class FluidShape : Shape
    {
        FluidParticle fixture;

        public FluidShape(FluidParticle fixture)
            : base()
        {
            this.fixture = fixture;
            m_type = ShapeType.FLUID;
        }

        public override Shape Clone()
        {
            FluidShape newShape = new FluidShape(fixture);
            return newShape;
        }

        public override int GetChildCount()
        {
            throw new NotImplementedException();
        }

        public override bool TestPoint(ref Transform xf, Microsoft.Xna.Framework.Vector2 p)
        {
            throw new NotImplementedException();
        }

        public override bool RayCast(out RayCastOutput output, ref RayCastInput input, ref Transform transform, int childIndex)
        {
            throw new NotImplementedException();
        }

        public override void ComputeAABB(out AABB aabb, ref Transform xf, int childIndex)
        {
            aabb = new AABB();
            aabb.lowerBound.X = fixture.position.X - fixture.gridSize;
            aabb.lowerBound.Y = fixture.position.Y - fixture.gridSize;
            aabb.upperBound.X = fixture.position.X + fixture.gridSize;
            aabb.upperBound.Y = fixture.position.Y + fixture.gridSize;
        }

        public override void ComputeMass(out MassData massData, float density)
        {
            throw new NotImplementedException();
        }
    }
}
