#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using starLiGHT.Collections;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Collision.

    starLiGHT.Collision is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Collision is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Collision.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

namespace starLiGHT.Physic.TwoD
{
    public class ManifoldPool : StaticPool<Manifold>
    {
        static ManifoldPool instance = new ManifoldPool();

        private ManifoldPool()
            : base(4096)
        {
        }

        public static ManifoldPool Instance
        {
            get { return instance; }
        }

        protected override Manifold AllocateNew()
        {
            return new Manifold();
        }
    }

    public class ContactEdgePool : StaticPool<ContactEdge>
    {
        static ContactEdgePool instance = new ContactEdgePool();

        private ContactEdgePool()
            : base(4096)
        {
        }

        public static ContactEdgePool Instance
        {
            get { return instance; }
        }

        protected override ContactEdge AllocateNew()
        {
            return new ContactEdge();
        }
    }

}