﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using starLiGHT.Physic.TwoD;
using Microsoft.Xna.Framework;
using starLiGHT.Collections;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Collision.

    starLiGHT.Collision is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Collision is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Collision.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1486                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-10-08 15:55:47 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Physic
{
    public delegate void PreSolveEventHandler(Object sender, TimeStep dt);

    public abstract class Controller2D
    {
        bool enabled;
        protected List<RigidBody2D> bodies;

        public Controller2D()
        {
            bodies = new List<RigidBody2D>();
        }

        public void AddBody(RigidBody2D body)
        {
            bodies.Add(body);
        }

        public void RemoveBody(RigidBody2D body)
        {
            bodies.Remove(body);
        }

        public void ClearBodies()
        {
            bodies.Clear();
        }

        public bool Enabled 
        {
            get { return enabled; }
            set
            {
                if (value == true)
                    PhysicSystem2D.Instance.enabledControllers++;
                else
                    PhysicSystem2D.Instance.enabledControllers--;

                enabled = value;
            }
        }

        public abstract void Update(TimeStep step);
    }
}
