﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

#endregion

#region COPYRIGHT

/*
    Copyright (c) 2008, 2009, 2010 
        Roland Rosenkranz (Glatzemann@email.de)
*/

#endregion

#region LICENSE

/*
    This file is part of starLiGHT.Collision.

    starLiGHT.Collision is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    starLiGHT.Collision is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with starLiGHT.Collision.  If not, see <http://www.gnu.org/licenses/>.

    
    ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

namespace starLiGHT.Physic.TwoD
{
    public abstract class SmoothingKernel
    {
        internal float m_factor;
        internal float m_kernelSize;
        internal float m_kernelSizeSq;
        internal float m_kernelSize3;

        public SmoothingKernel()
            : this(1.0f)
        {
        }

        public SmoothingKernel(float kernelSize)
        {
            this.m_factor = 1.0f;
            this.m_kernelSize = kernelSize;
            m_kernelSizeSq = m_kernelSize * m_kernelSize;
            m_kernelSize3 = m_kernelSize * m_kernelSize * m_kernelSize;
            calculateFactor();
        }

        internal abstract void calculateFactor();
        internal abstract float calculate(Vector2 distance);
        internal abstract Vector2 calculateGradient(Vector2 distance);
        internal abstract float calculateLaplacian(Vector2 distance);
    }
}
