#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="AxisCameraConstraint.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2007, 2008, 2009, 2010
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Render.
//
//   starLiGHT.Render is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Core is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Render. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Render are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 620                   $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2010-12-07 15:23:58 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Camera.TwoD
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Text;
    using Microsoft.Xna.Framework;

    #endregion

    public class AxisCameraConstraint : ICameraConstraint
    {
        private bool limitXAxis;
        private bool limitYAxis;
        private int sortOrder;

        public AxisCameraConstraint(bool limitXAxis, bool limitYAxis)
        {
            this.limitXAxis = limitXAxis;
            this.limitYAxis = limitYAxis;
        }

        public string Name
        {
            get { return "AxisCameraConstraint"; }
        }

        public int SortOrder
        {
            get { return this.sortOrder; }
            internal set { this.sortOrder = value; }
        }

        public bool LimitXAxis
        {
            get { return this.limitXAxis; }
            set { this.limitXAxis = value; }
        }

        public bool LimitYAxis
        {
            get { return this.limitYAxis; }
            set { this.limitYAxis = value; }
        }

        public Vector2 UpdatePosition(GameTime gameTime, Camera2D camera, Vector2 newPosition)
        {
            if (this.limitXAxis)
            {
                newPosition.X = camera.Anchor.X;
            }

            if (this.limitYAxis)
            {
                newPosition.Y = camera.Anchor.Y;
            }

            return newPosition;
        }
    }
}
