﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="CameraManager2D.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Render.
//
//   starLiGHT.Render is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Core is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Render. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Render are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 5425                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-02-18 15:38:38 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Render.Camera.TwoD
{
    #region Using Statements
    using System;
    using System.Collections.Generic;
    using System.Text;
    using Microsoft.Xna.Framework;
    using Microsoft.Xna.Framework.Graphics;
    using starLiGHT;
    using starLiGHT.Camera.TwoD;
    using starLiGHT.Collections;
    #endregion

    /// <summary>
    /// Derives from AbstractCameraManager.
    /// Provides functionalities for managing cameras intended for use in 2-dimensional space.
    /// </summary>
    public class CameraManager2D : AbstractCameraManager
    {
        /// <summary>
        /// Initializes a new instance of the CameraManager2D class.
        /// </summary>
        /// <param name="graphicsDevice">GraphicsDevice the manager uses for the cameras.</param>
        public CameraManager2D(GraphicsDevice graphicsDevice)
            : base(graphicsDevice)
        {
        }

#if !ZUNE
        /// <summary>
        /// Applies an Effect's Parameters to the manager.
        /// </summary>
        /// <param name="effect">Effect of which Parameters will be applied to the manager.</param>
        public override void ApplyCameraEffectParameters(ref Effect effect)
        {
            throw new NotImplementedException();
        }
#endif

        /// <summary>
        /// Updates the manager. The client needs to calls this function in order to update the managed cameras.
        /// </summary>
        /// <param name="gameTime">Provides snapshots of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            ////TODO: implement camera bounds
            if (ActiveCamera != null)
            {
                ((Camera2D)ActiveCamera).Update(gameTime, RectangleF.Empty);
            }
        }
    }
}
