﻿#region COPYRIGHT
//--------------------------------------------------------------------------------
// <copyright file="LightType.cs" company="starLiGHT Entertainment Studios">
//    Copyright (c) 2011
//       Roland Rosenkranz (Glatzemann@email.de)
// </copyright>
// <license>
//   This file is part of starLiGHT.Render.
//
//   starLiGHT.Render is free software: you can redistribute it and/or modify
//   it under the terms of the GNU Lesser General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   starLiGHT.Render is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU Lesser General Public License for more details.
//
//   You should have received a copy of the GNU Lesser General Public License
//   along with starLiGHT.Render. If not, see http://www.gnu.org/licenses/.
//    
//   ADDITIONAL (commercial) LICENSES for starLiGHT.Render are available on request.
// </license>
// <version>
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 7773                  $:  Revision of last commit *
// * $Author:: unknown            $:  Author of last commit   *
// * $Date:: 2011-03-28 02:04:04 #$:  Date of last commit     *
// ************************************************************
// </version>
//--------------------------------------------------------------------------------
#endregion

namespace starLiGHT.Light
{
    public enum LightType
    {
        /// <summary>
        /// Illuminates evenly in all directions
        /// </summary>
        Point,
        
        /// <summary>
        /// illuminates in one direction in an expanding cone
        /// </summary>
        Spot,
        
        /// <summary>
        /// illuminates in one direction without having an obious source of light
        /// </summary>
        Directional,
        
        /// <summary>
        /// gentle omni-directional illumination
        /// </summary>
        Ambient,
        
        /// <summary>
        /// rectangular light source useful for simulating lightbox reflections
        /// </summary>
        Area,

        /// <summary>
        /// geometrical volume that illuminates objects contained within the volume
        /// without illuminating objects outside the volume
        /// </summary>
        Volume,

        /// <summary>
        /// tube-like light
        /// </summary>
        Linear
    }
}
