﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using starLiGHT.Components.SandboxManager;
using starLiGHT.Collision;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
#endregion

namespace starLiGHT.Sandbox.Collision
{
    public abstract class CollisionSystemTest : SandboxTest
    {
        private CollisionManager collisionManager;
        protected bool singleStep = false;

        public CollisionSystemTest()
        {
            collisionManager = new CollisionManager();
        }

        public abstract void Initialize(Game1 game);
        
        public virtual void Update(GameTime gameTime, KeyboardState actState, KeyboardState lastState) 
        {
            if (actState.IsKeyDown(Keys.S) && lastState.IsKeyUp(Keys.S))
            {
                singleStep = !singleStep;
            }

            if (!singleStep || (singleStep && actState.IsKeyDown(Keys.C) && lastState.IsKeyUp(Keys.C)))
            {
                collisionManager.Update();
            }
        }

        public abstract void Draw(GameTime gameTime, SpriteBatch spriteBatch);

        public CollisionManager CollisionManager
        {
            get { return collisionManager; }
            protected set { collisionManager = value; }
        }
    }
}
