﻿#region Using Statements
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT.ParticleSystem.Common;
using starLiGHT.ParticleSystem.twoD;
using Microsoft.Xna.Framework.Content;
using starLiGHT.ParticleSystem.PulseGenerators;
using starLiGHT.ParticleSystem.Initializer;
using starLiGHT.ParticleSystem.Initializer.TwoD;
using starLiGHT.ParticleSystem.Modifier;
using starLiGHT.ParticleSystem.Modifier.twoD;
#endregion

namespace starLiGHT.Sandbox.Particles
{
    public class Magic : Emitter2D
    {
        public Magic(ContentManager content)
        {
            PulseGenerator = new Steady(15);

            addInitializer(new TextureInitializer(content.Load<Texture2D>("star2")));
            addInitializer(new Lifetime(2, 3));
            addInitializer(new Position(new DiscRegion(new Vector2(400, 300), 20.0f, 5.0f)));
            addInitializer(new Velocity(new DiscRegion(new Vector2(0, 0), 100, 10)));
            addInitializer(new starLiGHT.ParticleSystem.Initializer.Scale(0.25f, 1.00f));
            addInitializer(new RotateVelocity(-2.25f, 2.25f));
            addInitializer(new ColorInitializer(Color.Yellow, Color.Magenta));

            addModifier(new Age());
            addModifier(new Move());
            addModifier(new Fade(1.0f, 0.0f));
            addModifier(new Rotate());
            addModifier(new RandomDrift(new Vector2(30, 30)));
            addModifier(new starLiGHT.ParticleSystem.Modifier.Scale(0.2f, 1.0f));
            //addModifier(new Accelerate(0, 30));
        }
    }
}
