﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1296                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-08-17 13:17:41 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class Cantilever : Test
    {
        static int e_count = 8;

        public Cantilever(Microsoft.Xna.Framework.Game game)
            : base(game, 4.0f)
        {
            RigidBody2D ground = PhysicSystem2D.Instance.createEdge(new Vector2(-40.0f, 0.0f), new Vector2(40.0f, 0.0f));

		    {
			    RigidBody2D prevBody = ground;
			    for (Int32 i = 0; i < e_count; ++i)
			    {
                    RigidBody2D body = PhysicSystem2D.Instance.createBox(new Vector2(-14.5f + 1.0f * i, 5.0f), new Vector2(0.5f, 0.125f), 0.2f, 20.0f);
                    PhysicSystem2D.Instance.createWeldJoint(prevBody, body, new Vector2(-15.0f + 1.0f * i, 5.0f));
				    prevBody = body;
			    }
		    }

            {
                RigidBody2D prevBody = ground;
                for (Int32 i = 0; i < e_count; ++i)
                {
                    RigidBody2D body = PhysicSystem2D.Instance.createBox(new Vector2(-14.5f + 1.0f * i, 15.0f), new Vector2(0.5f, 0.125f), 0.2f, 20.0f);
                    PhysicSystem2D.Instance.createWeldJoint(prevBody, body, new Vector2(-15.0f + 1.0f * i, 15.0f));
                    prevBody = body;
                }
            }

            {
                RigidBody2D prevBody = ground;
                for (Int32 i = 0; i < e_count; ++i)
                {
                    RigidBody2D body = PhysicSystem2D.Instance.createBox(new Vector2(-4.5f + 1.0f * i, 5.0f), new Vector2(0.5f, 0.125f), 0.2f, 20.0f);
                    if (i > 0)
                        PhysicSystem2D.Instance.createWeldJoint(prevBody, body, new Vector2(-5.0f + 1.0f * i, 5.0f));
                    prevBody = body;
                }
            }

            {
                RigidBody2D prevBody = ground;
                for (Int32 i = 0; i < e_count; ++i)
                {
                    RigidBody2D body = PhysicSystem2D.Instance.createBox(new Vector2(5.5f + 1.0f * i, 10.0f), new Vector2(0.5f, 0.125f), 0.2f, 20.0f);
                    if (i > 0)
                        PhysicSystem2D.Instance.createWeldJoint(prevBody, body, new Vector2(5.0f + 1.0f * i, 10.0f));
                    prevBody = body;
                }
            }

		    for (Int32 i = 0; i < 2; ++i)
		    {
			    Vector2[] vertices = new Vector2[3];
                vertices[0] = new Vector2(-0.5f, 0.0f);
                vertices[1] = new Vector2(0.5f, 0.0f);
                vertices[2] = new Vector2(0.0f, 1.5f);

                PhysicSystem2D.Instance.createPolygon(-8.0f + 8.0f * i, 12.0f, vertices);
		    }

		    for (Int32 i = 0; i < 2; ++i)
		    {
                PhysicSystem2D.Instance.createCircle(-6.0f + 6.0f * i, 10.0f, 0.5f, 1.0f);
		    }
        }
    }
}
