﻿#region Using Statements
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1298                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-08-17 14:37:53 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class CompoundShapes : Test
    {
	    public CompoundShapes(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
	    {
            RigidBody2D ground = PhysicSystem2D.Instance.createEdge(new Vector2(50.0f, 0.0f), new Vector2(-50.0f, 0.0f));

            for (int i = 0; i < 10; ++i)
            {
                RigidBody2D body = PhysicSystem2D.Instance.createBody(BodyType.DYNAMIC, 
                                                                      RandomFloat(-0.1f, 0.1f) + 5.0f, 
                                                                      1.05f + 2.5f * i, 
                                                                      RandomFloat(-(float)System.Math.PI, (float)System.Math.PI)
                                                                     );
                body.addCircle(-0.5f, 0.5f, 0.5f);
                body.addCircle( 0.5f, 0.5f, 0.5f);
            }

            for (int i = 0; i < 10; ++i)
            {
                RigidBody2D body = PhysicSystem2D.Instance.createBody(BodyType.DYNAMIC,
                                                                      RandomFloat(-0.1f, 0.1f) - 5.0f,
                                                                      1.05f + 2.5f * i,
                                                                      RandomFloat(-(float)System.Math.PI, (float)System.Math.PI)
                                                                     );
                body.addBox(0.0f, 0.0f, 0.25f, 0.5f, Vector2.Zero, 0.0f, 2.0f);
                body.addBox(0.0f, 0.0f, 0.25f, 0.5f, new Vector2(0.0f, -0.5f), 0.5f * (float)System.Math.PI, 2.0f);
            }
  
            Transform xf1 = new Transform(); 
            xf1.R.Set(0.3524f * (float)System.Math.PI); 
            xf1.position = Math.Mul(xf1.R, new Vector2(1.0f, 0.0f)); 

            Vector2[] triangle1 = new Vector2[3]; 
            triangle1[0] = Math.Mul(xf1, new Vector2(-1.0f, 0.0f));
            triangle1[1] = Math.Mul(xf1, new Vector2(1.0f, 0.0f));
            triangle1[2] = Math.Mul(xf1, new Vector2(0.0f, 0.5f)); 

            Transform xf2 = new Transform(); 
            xf2.R.Set(-0.3524f * (float)System.Math.PI); 
            xf2.position = Math.Mul(xf2.R, new Vector2(-1.0f, 0.0f)); 

            Vector2[] triangle2 = new Vector2[3];
            triangle2[0] = Math.Mul(xf2, new Vector2(-1.0f, 0.0f));
            triangle2[1] = Math.Mul(xf2, new Vector2(1.0f, 0.0f));
            triangle2[2] = Math.Mul(xf2, new Vector2(0.0f, 0.5f)); 

            for (int i = 0; i < 10; ++i) 
            {
                RigidBody2D body = PhysicSystem2D.Instance.createBody(BodyType.DYNAMIC,
                                                                   RandomFloat(-0.1f, 0.1f),
                                                                   2.05f + 2.5f * i,
                                                                   0f
                                                                  );
                body.addPolygon(2.0f, triangle1);
                body.addPolygon(2.0f, triangle2);
            }

            RigidBody2D cup = PhysicSystem2D.Instance.createBody(BodyType.DYNAMIC, 0.0f, 2.0f);
            cup.addBox(0.0f, 0.0f, 1.5f, 0.15f, Vector2.Zero, 0.0f, 4.0f);
            cup.addBox(0.0f, 0.0f, 0.15f, 2.7f, new Vector2(-1.45f, 2.35f), 0.2f, 4.0f);
            cup.addBox(0.0f, 0.0f, 0.15f, 2.7f, new Vector2(1.45f, 2.35f), -0.2f, 4.0f);
        }
    }
}
