﻿#region Using Statements
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1299                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-08-17 16:17:41 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class Dominos : Test
    {
        public Dominos(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
        {
            RigidBody2D b1 = PhysicSystem2D.Instance.createEdge(new Vector2(-40.0f, 0.0f), new Vector2(40.0f, 0.0f));

            RigidBody2D ground1 = PhysicSystem2D.Instance.createBox(BodyType.STATIC, -1.5f, 10.0f, 6.0f, 0.25f);

            for (int i = 0; i < 10; ++i)
            {
                PhysicSystem2D.Instance.createBox(-6.0f + 1.0f * i, 11.25f, 0.1f, 1.0f, 0.1f, 20.0f);
            }

            PhysicSystem2D.Instance.createBox(BodyType.STATIC, new Vector2(1.0f, 6.0f), new Vector2(7.0f, 0.25f), Vector2.Zero, 0.3f, 0.2f, 0.0f);

            RigidBody2D b2 = PhysicSystem2D.Instance.createBox(BodyType.STATIC, -7.0f, 4.0f, 0.25f, 1.5f);

            RigidBody2D b3 = PhysicSystem2D.Instance.createBox(BodyType.DYNAMIC, new Vector2(-0.9f, 1.0f), new Vector2(6.0f, 0.125f), Vector2.Zero, -0.15f, 0.2f, 10.0f);

            RigidBody2D b4 = PhysicSystem2D.Instance.createBox(BodyType.DYNAMIC, -10.0f, 15.0f, 0.25f, 0.25f, 0.2f, 10.0f);
            PhysicSystem2D.Instance.createRevoluteJoint(b1, b3, new Vector2(-2.0f, 1.0f), true);
            PhysicSystem2D.Instance.createRevoluteJoint(b2, b4, new Vector2(-7.0f, 15.0f), true);

            RigidBody2D b5 = PhysicSystem2D.Instance.createBody(BodyType.DYNAMIC, 6.5f, 3.0f);
            b5.addBox(0.0f, 0.0f, 1.0f, 0.1f, new Vector2(0.0f, -0.9f), 0.0f, 10.0f);
            b5.addBox(0.0f, 0.0f, 0.1f, 1.0f, new Vector2(-0.9f, 0.0f), 0.0f, 10.0f);
            b5.addBox(0.0f, 0.0f, 0.1f, 1.0f, new Vector2(0.9f,  0.0f), 0.0f, 10.0f);

            PhysicSystem2D.Instance.createRevoluteJoint(b1, b5, new Vector2(6.0f, 2.0f), true);

            RigidBody2D b6 = PhysicSystem2D.Instance.createBox(BodyType.DYNAMIC, 6.5f, 4.1f, 1.0f, 0.1f, 0.2f, 30.0f);

            PhysicSystem2D.Instance.createRevoluteJoint(b5, b6, new Vector2(7.5f, 4.0f), true);

            RigidBody2D b7 = PhysicSystem2D.Instance.createBox(BodyType.DYNAMIC, 7.4f, 1.0f, 0.1f, 1.0f, 0.2f, 10.0f);

            DistanceJoint dj = PhysicSystem2D.Instance.createDistanceJoint(b3, new Vector2(6.0f, 0.0f), b7, new Vector2(0.0f, -1.0f));

            float radius = 0.2f;
            for (int i = 0; i < 4; ++i)
            {
                PhysicSystem2D.Instance.createCircle(BodyType.DYNAMIC, 5.9f + 2.0f * radius, 2.4f, radius, 0.2f, 10.0f);
            }
        }

    }
}
