﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1409                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-09-09 07:27:44 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class Fluid : Test
    {
        static int e_columnCount = 0;
        static int e_rowCount = 0;

        public Fluid(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
        {
            //{
            //BodyDef bd = new BodyDef();
            //Body ground = m_world.CreateBody(bd);

            //    PolygonShape shape = new PolygonShape();

            //    // Floor
            //    shape.SetAsEdge(new Vector2(-10.0f, 0.0f), new Vector2(10.0f, 0.0f));
            //    ground.CreateFixture(shape);

            //    PolygonShape shape2 = new PolygonShape();

            //    // Left wall
            //    shape2.SetAsEdge(new Vector2(-10.0f, 0.0f), new Vector2(-10.0f, 20.0f));
            //    ground.CreateFixture(shape2);

            //    PolygonShape shape3 = new PolygonShape();

            //    // Right wall
            //    shape3.SetAsEdge(new Vector2(10.0f, 0.0f), new Vector2(10.0f, 20.0f));
            //    ground.CreateFixture(shape3);

            //    PolygonShape shape4 = new PolygonShape();

            //    // Roof
            //    shape4.SetAsEdge(new Vector2(-10.0f, 20.0f), new Vector2(10.0f, 20.0f));
            //    ground.CreateFixture(shape4);
            //}

            // SPH test
            for (int i = 0; i < 10; i++)
            {
                BodyDef bd = new BodyDef();
                bd.type = BodyType.KINEMATIC;
                Body fluidParticle = m_world.CreateBody(bd);

                FluidParticle p = new FluidParticle(new Vector2(0.0f, 20.0f), 0.4f, 0.5f, m_world);
                fluidParticle.CreateFixture(new FluidShape(p), 0.0f);

                m_world.addFluidParticle(p);
            }

        }

        void CreateCircle()
        {
            float radius = 0.5f;
            CircleShape shape = new CircleShape();
            shape.m_p = Vector2.Zero;
            shape.m_radius = radius;

            FixtureDef fd = new FixtureDef();
            fd.shape = shape;
            fd.density = 1.0f;
            fd.friction = 0.0f;

            BodyDef bd = new BodyDef();
            bd.type = BodyType.DYNAMIC;
            bd.position = new Vector2(starLiGHT.Physic.TwoD.Math.Random(), (2.0f + starLiGHT.Physic.TwoD.Math.Random()) * radius);
            Body body = m_world.CreateBody(bd);

            body.CreateFixture(fd);
        }

        public override void Keyboard(KeyboardDevice keyboard, starLiGHT.Input.InputManager input)
        {
            base.Keyboard(keyboard, input);

            if (keyboard.GetKey(Keys.C).Pressed)
            {
                CreateCircle();
            }
        }

        public override void Step(GraphicsDevice graphicsDevice, Settings settings)
        {
            Int32 flag = settings.enableContinuous;
            settings.enableContinuous = 0;
            base.Step(graphicsDevice, settings);
            settings.enableContinuous = flag;
        }
    }
}
