﻿#region Using Statements
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1482                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-10-07 11:53:48 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class Gears : Test
    {
        public Gears(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
        {
            // Ground body
            RigidBody2D ground = PhysicSystem2D.Instance.createEdge(new Vector2(50.0f, 0.0f), new Vector2(-50.0f, 0.0f)); 

            {
                CircleShape circle1 = new CircleShape();
                circle1.m_radius = 1.0f;

                CircleShape circle2 = new CircleShape();
                circle2.m_radius = 2.0f;

                PolygonShape box = new PolygonShape();
                box.SetAsBox(0.5f, 5.0f);

                BodyDef bd1 = new BodyDef();
                bd1.type = BodyType.DYNAMIC;
                bd1.position = new Vector2(-3.0f, 12.0f);
                Body body1 = m_world.CreateBody(bd1);
                body1.CreateFixture(circle1, 5.0f);

                RevoluteJointDef jd1 = new RevoluteJointDef();
                jd1.body1 = ground.Body;
                jd1.body2 = body1;
                jd1.localAnchor1 = ground.Body.GetLocalPoint(bd1.position);
                jd1.localAnchor2 = body1.GetLocalPoint(bd1.position);
                jd1.referenceAngle = body1.Angle - ground.Angle;
                m_joint1 = m_world.CreateJoint(jd1) as RevoluteJoint;

                BodyDef bd2 = new BodyDef();
                bd2.type = BodyType.DYNAMIC;
                bd2.position = new Vector2(0.0f, 12.0f);
                Body body2 = m_world.CreateBody(bd2);
                body2.CreateFixture(circle2, 5.0f);

                RevoluteJointDef jd2 = new RevoluteJointDef();
                jd2.Initialize(ground.Body, body2, bd2.position);
                m_joint2 = m_world.CreateJoint(jd2) as RevoluteJoint;

                BodyDef bd3 = new BodyDef();
                bd3.type = BodyType.DYNAMIC;
                bd3.position = new Vector2(2.5f, 12.0f);
                Body body3 = m_world.CreateBody(bd3);
                body3.CreateFixture(box, 5.0f);

                PrismaticJointDef jd3 = new PrismaticJointDef();
                jd3.Initialize(ground.Body, body3, bd3.position, new Vector2(0.0f, 1.0f));
                jd3.lowerTranslation = -5.0f;
                jd3.upperTranslation = 5.0f;
                jd3.enableLimit = true;

                m_joint3 = m_world.CreateJoint(jd3) as PrismaticJoint;

                GearJointDef jd4 = new GearJointDef();
                jd4.body1 = body1;
                jd4.body2 = body2;
                jd4.joint1 = m_joint1;
                jd4.joint2 = m_joint2;
                jd4.ratio = circle2.m_radius / circle1.m_radius;
                m_joint4 = m_world.CreateJoint(jd4) as GearJoint;

                GearJointDef jd5 = new GearJointDef();
                jd5.body1 = body2;
                jd5.body2 = body3;
                jd5.joint1 = m_joint2;
                jd5.joint2 = m_joint3;
                jd5.ratio = -1.0f / circle2.m_radius;
                m_joint5 = m_world.CreateJoint(jd5) as GearJoint;
            }
        }

        //public override void Step(Settings settings)
        //{
        //    base.Step(settings);

        //    float ratio, value;

        //    //ratio = m_joint4.GetRatio();
        //    //value = m_joint1.GetJointAngle() + ratio * m_joint2.GetJointAngle();
        //    //m_debugDraw.DrawString(5, m_textLine, String.Format("theta1 + {0} * theta2 = {1}", (float)ratio, (float)value));
        //    //m_textLine += 15;

        //    //ratio = m_joint5.GetRatio();
        //    //value = m_joint2.GetJointAngle() + ratio * m_joint3.GetJointTranslation();
        //    //m_debugDraw.DrawString(5, m_textLine, String.Format("theta2 + {0} * delta = {1}", (float)ratio, (float)value));
        //    //m_textLine += 15;
        //}

        RevoluteJoint m_joint1;
        RevoluteJoint m_joint2;
        PrismaticJoint m_joint3;
        GearJoint m_joint4;
        GearJoint m_joint5;
    }
}
