﻿#region Using Statements
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1482                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-10-07 11:53:48 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class Pulleys : Test
    {
        PulleyJoint m_joint1;

        public Pulleys(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
        {
            // Ground body
            RigidBody2D ground = PhysicSystem2D.Instance.createEdge(new Vector2(-40.0f, 0.0f), new Vector2(40.0f, 0.0f)); 

            { 
                float a = 2.0f; 
                float b = 4.0f; 
                float y = 16.0f; 
                float L = 12.0f; 

                PolygonShape shape = new PolygonShape(); 
                shape.SetAsBox(a, b); 

                BodyDef bd = new BodyDef(); 
                bd.type = BodyType.DYNAMIC; 

                bd.position = new Vector2(-10.0f, y); 
                Body body1 = m_world.CreateBody(bd); 
                body1.CreateFixture(shape, 5.0f); 

                bd.position = new Vector2(10.0f, y); 
                Body body2 = m_world.CreateBody(bd); 
                body2.CreateFixture(shape, 5.0f); 

                PulleyJointDef pulleyDef = new PulleyJointDef(); 
                Vector2 anchor1 = new Vector2(-10.0f, y + b); 
                Vector2 anchor2 = new Vector2(10.0f, y + b); 
                Vector2 groundAnchor1 = new Vector2(-10.0f, y + b + L);
                Vector2 groundAnchor2 = new Vector2(10.0f, y + b + L); 
                pulleyDef.Initialize(body1, body2, groundAnchor1, groundAnchor2, anchor1, anchor2, 2.0f); 

                m_joint1 = (PulleyJoint)m_world.CreateJoint(pulleyDef); 
            } 
        }

        //public override void Step(Settings settings)
        //{
        //    base.Step(settings);
        //}

        public override void Draw(Settings settings, SpriteBatch spriteBatch, SpriteFont font)
        {
            base.Draw(settings, spriteBatch, font);

            float ratio = m_joint1.GetRatio();
            float L = m_joint1.GetLength1() + ratio * m_joint1.GetLength2();
            m_debugDraw.DrawString(spriteBatch, font, 5, m_textLine, System.String.Format("L1 + {0} * L2 = {1}", ratio, L));
            m_textLine += 15; 
         }
    }
}
