﻿#region Using Statements
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using starLiGHT.Physic.TwoD;
using starLiGHT.Input;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using starLiGHT;
using starLiGHT.Physic;

#endregion

#region LICENSE

/*
    * This file is part of starLiGHT.Collision.
    * Copyright (c) 2007-2010 Roland Rosenkranz http://www.starLiGHT-Engine.de

    * This software is provided 'as-is', without any express or implied
    * warranty.  In no event will the authors be held liable for any damages
    * arising from the use of this software.
    * Permission is granted to anyone to use this software for any purpose,
    * including commercial applications, and to alter it and redistribute it
    * freely, subject to the following restrictions:
    * 1. The origin of this software must not be misrepresented; you must not
    * claim that you wrote the original software. If you use this software
    * in a product, an acknowledgment in the product documentation would be
    * appreciated but is not required.
    * 2. Altered source versions must be plainly marked as such, and must not be
    * misrepresented as being the original software.
    * 3. This notice may not be removed or altered from any source distribution.
    
    * ADDITIONAL (commercial) LICENSES for starLiGHT.Collision are available on request.
*/

#endregion

#region Original Box2D License

/*
* Copyright (c) 2006-2009 Erin Catto http://www.gphysics.com
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/

#endregion

#region Version Stuff
// **************[ starLiGHT.Engine SVN ]**********************
// * $Rev:: 1215                  $:  Revision of last commit *
// * $Author:: glatzemann         $:  Author of last commit   *
// * $Date:: 2010-08-06 11:27:01 #$:  Date of last commit     *
// ************************************************************
#endregion

namespace starLiGHT.Sandbox.Physic2D
{
    public class VaryingFriction : Test
    {
	    public VaryingFriction(Microsoft.Xna.Framework.Game game)
            : base(game, 3.0f)
	    {
            PhysicSystem2D.Instance.createEdge(new Vector2(-40.0f, 0.0f), new Vector2(40.0f, 0.0f));

            PhysicSystem2D.Instance.createBox(BodyType.STATIC,  -4.0f, 22.0f, 13.0f, 0.25f, -0.25f, 0.2f, 0.0f);
            PhysicSystem2D.Instance.createBox(BodyType.STATIC,  10.5f, 19.0f, 0.25f, 1.0f, 0.2f, 0.0f);
            PhysicSystem2D.Instance.createBox(BodyType.STATIC,   4.0f, 14.0f, 13.0f, 0.25f,  0.25f, 0.2f, 0.0f);
            PhysicSystem2D.Instance.createBox(BodyType.STATIC, -10.5f, 11.0f, 0.25f, 1.0f, 0.2f, 0.0f);
            PhysicSystem2D.Instance.createBox(BodyType.STATIC,  -4.0f,  6.0f, 13.0f, 0.25f, -0.25f, 0.2f, 0.0f);

            float[] friction = {0.75f, 0.5f, 0.35f, 0.1f, 0.0f}; 

            for (int i = 0; i < 5; ++i) 
            {
                PhysicSystem2D.Instance.createBox(new Vector2(-15.0f + 4.0f * i, 28.0f), 0.5f, 0.5f, friction[i], 25.0f);
            } 
         }
    }
}
